<template>
  <v-row no-gutters class="fill-height">
    <v-col cols="12" style="border-bottom: 1px solid #b8b8b8;">
      <v-toolbar id="toolbar" color="elevation-0">
            <span class="subheading font-weight-bold">{{
              conversationData.title
            }}</span>

            <v-btn icon class="ml-10">
              <v-avatar v-if="conversationData.imageUrl" size="35">
                <v-img :src="conversationData.imageUrl"></v-img>
              </v-avatar>
            </v-btn>
            <v-divider class="mx-4" vertical></v-divider>
            <div>
              <v-btn text>
                <i class="far fa-clock mr-2"></i>
                {{
                  conversationData &&
                    conversationData.dateItem &&
                    conversationData.dateItem.date
                }}
                at
                {{
                  conversationData &&
                    conversationData.dateItem &&
                    conversationData.dateItem.time
                }}
              </v-btn>
              <v-btn @click="openVideoCall(conversationData)" text>
                <i class="fas fa-mobile-alt mr-2"></i>
                Join video call
              </v-btn>
            </div>
          </v-toolbar>
    </v-col>
    <v-col
      cols="12"
      :style="'border-left: 1px solid #cacaca; height:' + getChatHeight + 'px;'"
    >
      <MobileChat :chat-id="chatId" />
    </v-col>
  </v-row>
</template>

<script>
import MobileChat from './MobileChat'

export default {
  props: {
    groupType: {
      type: String,
      default: 'facilitator'
    }
  },
  name: 'ChatWrapper',
  components: {
    MobileChat
  },
  data() {
    return {
      loading: false,
      messages: [],
      chatGroups: [],
      chatId: null,
      groupChatInfo: {}
    }
  },
  watch: {
    chatId: {
      async handler(chatId) {
        this.$forceUpdate()
        await this.$store.commit('conversations/clearConversations')
        if (chatId) {
          await this.$store.commit('conversations/addGroupChatId', chatId)
          await this.$store
            .dispatch('conversations/getConversation')
            .then(() => {})
            .catch(err => {
              chatId = null
              this.$store.commit('conversations/clearConversations')
              console.log(err)
            })
        }
      }
    }
  },
  computed: {
    conversationData() {
      return this.$store.state.conversations.groupChatInfo
    },
    user() {
      return this.$store.state.authentication.user
    },
    getChatHeight() {
      let toolbar = 120
      let winHeight = 0
      this.$nextTick(() => {
        toolbar = document.getElementById('toolbar').clientHeight
      })
      winHeight = window.innerHeight - 45
      return winHeight - toolbar
    },
    windowHeight() {
      return window.innerHeight
    }
  },
  mounted() {
    this.disableScroll()
    this.$store.commit('conversations/addGroupChatId', this.$route.params.id)

    this.$store
      .dispatch('conversations/getConversationData')
      .then(() => {})
      .catch(err => {
        console.log(err)
      })
  },
  created() {
    this.$store.commit('conversations/addGroupChatId', this.$route.params.id)
  },
  methods: {
    disableScroll() {
      document.documentElement.style.height = '100%'
      document.documentElement.style.overflow = 'hidden'
    },
    enableScroll() {
      document.documentElement.style.height = ''
      document.documentElement.style.overflow = ''
    },
    openVideoCall(data) {
      if (data.videoType === 'zoom' && data.videoURL !== '') {
        window.open(data.videoURL)
      }
    }
  },
  destroyed() {
    this.$store.commit('conversations/clearConversations')
    this.enableScroll()
  }
}
</script>

<style lang="scss"></style>
